%global namedversion %{version}%{?namedreltag}

%global surefire_version 2.15

Name:           jackson-core
Version:        2.3.0
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        Jackson-core
License:        ASL 2.0
Group:          Development/Java
URL:            http://wiki.fasterxml.com/JacksonHome
%if 0
/bin/rm -rf jackson-core-2.3.0.tar.xz jackson-core-2.3.0/ jackson-core/ .gitignore
/usr/bin/git clone -q -n https://github.com/FasterXML/jackson-core.git
cd jackson-core/
/usr/bin/git archive --prefix=jackson-core-2.3.0/ jackson-core-2.3.0 | /usr/bin/xz -9 > ../jackson-core-2.3.0.tar.xz
cd ../
/usr/bin/rhpkg new-sources jackson-core-2.3.0.tar.xz
/usr/bin/rhpkg prep
%endif
Source0:        jackson-core-2.3.0.tar.xz
Patch0:         0000-jackson-core-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       fasterxml-oss-parent >= 0:11
BuildRequires:  fasterxml-oss-parent >= 0:11
BuildRequires:  junit >= 0:4.8.2
# XXX: 1.0-beta-6
BuildRequires:  wagon-ssh-external >= 0:1.0
BuildRequires:  maven-scm-provider-gitexe >= 0:1.6
BuildRequires:  maven-scm-manager-plexus >= 0:1.6
# FIXME:
#BuildRequires:  wagon-gitsite >= 0:0.3.1
BuildRequires:  maven-javadoc-plugin >= 0:2.8.1
# XXX: 3.1
BuildRequires:  maven-site-plugin >= 0:2.4
BuildRequires:  maven-surefire-plugin >= 0:%{surefire_version}
BuildRequires:  maven-replacer-plugin
BuildRequires:  maven-javadoc-plugin >= 0:2.8.1
#
BuildRequires:  maven-bundle-plugin >= 0:2.3.7
BuildRequires:  build-helper-maven-plugin >= 0:1.7
BuildRequires:  maven-scm-plugin >= 0:1.7
BuildRequires:  doclava >= 0:1.0.3
BuildRequires:  jsilver >= 0:1.0.0
BuildRequires:  maven-jxr-plugin >= 0:2.3
# 2.0-beta-2
BuildRequires:  jdepend-maven-plugin >= 0:2.0
BuildRequires:  maven-surefire-report-plugin >= 0:2.15
BuildRequires:  maven-pmd-plugin >= 0:2.7.1
BuildRequires:  taglist-maven-plugin >= 0:2.4
BuildRequires:  maven-fluido-skin >= 0:1.1
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-remote-resources-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/jackson-core-%{namedversion}-%{release}-root

%description
Core Jackson abstractions, basic JSON streaming API implementation.

%package -n jackson-core-javadoc
Summary:        Javadoc for jackson-core
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n jackson-core-javadoc
%{summary}.

%package -n jackson-core-site
Summary:        Site for jackson-core
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       jackson-core-javadoc = %{epoch}:%{version}-%{release}

%description -n jackson-core-site
%{summary}.

%prep
%setup -q -n jackson-core-%{version}
%patch0 -p1 -b .0000~

%build
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Dsurefire.version=%{surefire_version} -Denforcer.skip deploy javadoc:aggregate site

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-core/%{namedversion}/jackson-core-%{namedversion}.jar %{buildroot}%{_javadir}/jackson-core-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-core/%{namedversion}/jackson-core-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jackson-core-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-core/%{namedversion}/jackson-core-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jackson-core-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/core/jackson-core/%{namedversion}/jackson-core-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jackson-core.pom

# depmaps
%add_to_maven_depmap com.fasterxml.jackson.core jackson-core %{namedversion} JPP jackson-core
[ %{name} = "jackson-core" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jackson-core

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jackson-core-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/jackson-core-%{namedversion}
%{__ln_s} jackson-core-%{namedversion} %{buildroot}%{_javadocdir}/jackson-core

# site
%{__mkdir_p} %{buildroot}%{_docdir}/jackson-core-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/jackson-core-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/jackson-core-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/jackson-core %{buildroot}%{_docdir}/jackson-core-%{namedversion}/apidocs
%{__ln_s} jackson-core-%{namedversion} %{buildroot}%{_docdir}/jackson-core

%clean
%{__rm} -rf %{buildroot}

%post -n jackson-core
%update_maven_depmap

%postun -n jackson-core
%update_maven_depmap

%files -n jackson-core
%defattr(0644,root,root,0755)
%{_javadir}/jackson-core-%{namedversion}.jar
%{_javadir}/jackson-core.jar
%{_javadir}/jackson-core-%{namedversion}-javadoc.jar
%{_javadir}/jackson-core-javadoc.jar
%{_javadir}/jackson-core-%{namedversion}-sources.jar
%{_javadir}/jackson-core-sources.jar
%{_mavenpomdir}/JPP-jackson-core.pom
%{_mavendepmapfragdir}/jackson-core

%files -n jackson-core-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jackson-core-%{namedversion}
%{_javadocdir}/jackson-core

%files -n jackson-core-site
%defattr(0644,root,root,0755)
%{_docdir}/jackson-core-%{namedversion}
%{_docdir}/jackson-core

%changelog
* Mon Dec 16 2013 David Walluck <dwalluck@redhat.com> 0:2.3.0-1
- 2.3.0

* Fri Aug 23 2013 David Walluck <dwalluck@redhat.com> 0:2.2.3-1
- 2.2.3

* Wed Aug 07 2013 David Walluck <dwalluck@redhat.com> 0:2.2.2-1
- release
